$regfile = "M128def.dat"                                    'IT'S POSSIBLE USE DIFFERENT AVR-CHIPS
$crystal = 8000000                                          'BUT this NOT TESTED
$baud = 128000
'-------------------------------------------------------------------------------
$swstack = 128
$hwstack = 128
$framesize = 1024
Config Date = Dmy , Separator = .
Config Lcdpin = Pin , Db4 = Pinf.3 , Db5 = Pinf.2 , Db6 = Pinf.1 , Db7 = _
Pinf.0 , Rs = Pinf.5 , E = Pinf.4
Config Lcd = 16 * 2
Cursor Off
Cls
Config Portd = Input
Portd = 255

'-------------------------------------------------------------------------------
  Avanti Alias Pind.0
     Led Alias Portg.1
 Vs_miso Alias Portc.0
 Vs_mosi Alias Portc.1
Vs_clock Alias Portc.2
     Xcs Alias Portc.3
  Xreset Alias Portc.5
    Dreq Alias Pinc.4
   Bsync Alias Portc.6
'-------------------------------------------------------------------------------
Config Avanti = Input
Config Led = Output
Config Vs_miso = Input
Config Vs_mosi = Output
Config Vs_clock = Output
Config Xcs = Output
Config Xreset = Output
Config Dreq = Input
Config Bsync = Output
'-------------------------------------------------------------------------------
Declare Sub Vs_init()
Declare Sub Soft_reset()
Declare Sub Vs_write(byval Vs_address As Byte , Byval Data1 As Byte , Byval Data2 As Byte)
Declare Function Vs_read(byval Vs_address As Byte) As Word
Declare Sub Send_mp3(byval Filename As String)
'-------------------------------------------------------------------------------
Const Vs_rd = &B0000_0011
Const Vs_wr = &B0000_0010
Const Vs_mode = 0
Const Vs_status = 1
Const Vs_clockf = 3
Const Vs_decode_time = 4
Const Vs_audata = 5
Const Vs_volume = 11
'-------------------------------------------------------------------------------
Dim B As Byte
Dim Test As Byte
Dim I As Integer
Dim J As Long
Dim Curbyte As Long
Dim S As String * 20
Dim Sample_rate As Word
Dim Bit_rate As Word
Dim Is_stereo As Word
Dim Audata As Word
Dim Filename As String * 11
Dim Mmc_data(512) As Byte
Dim Tempo_new As Word
Dim Tempo_old As Word
Dim Flag_read As Bit
Dim Flag_play As Bit
Dim Comando As String * 10
Dim Mode_low As Byte
Dim Mode_hig As Byte
Dim Volume As Word
Dim Volume_low As Byte
Dim Volume_hig As Byte
'-------------------------------------------------------------------------------
$include "Config_MMC.bas"
If Gbdriveerror <> 0 Then
Locate 2 , 1
Lcd "ERROR" ; Gbdriveerror
 End
 End If
$include "Config_AVR-DOS.BAS"

B = Initfilesystem(1)
If B <> 0 Then Lcd "Errore MMC"
'-------------------------------------------------------------------------------
Bsync = 0
Xreset = 0
Xcs = 1

Flag_play = 0
Flag_read = 1
'-------------------------------------------------------------------------------
'--------------------------  PROGRAM START -------------------------------------
'-------------------------------------------------------------------------------
Cls
'-------------------------------------------------------------------------------
'---------------------- crea una lista dei brani mp3 presenti sulla MMC --------
'-------------------------------------------------------------------------------
Open "List.txt" For Output As #9
S = Dir( "*.mp3")
While Len(s) > 0
   Print S ; "  " ; Filedate() ; "  " ; Filetime() ; "  " ; Filelen()
   Print #9 , S
   S = Dir()
Wend
Close #9
'-------------------------------------------------------------------------------
Locate 2 , 1
Lcd "VS1011 Init"
Vs_init
'-------------------------------------------------------------------------------
'--------------------------- MAIN PROGRAMM -------------------------------------
'-------------------------------------------------------------------------------
Do
  Open "List.txt" For Input As #9
        While Eof(#9) = 0
           Line Input #9 , S
           Call Send_mp3(s)
        Wend
  Close #9
Loop
End
'-------------------------------------------------------------------------------
'------------------------------ MP3 SUBROUTINES --------------------------------
'-------------------------------------------------------------------------------
Function Vs_read(byval Vs_address As Byte) As Word
  Xcs = 0
   B = Vs_rd
   Shiftout Vs_mosi , Vs_clock , B , 1
   Shiftout Vs_mosi , Vs_clock , Vs_address , 1
   B = 0
   Shiftin Vs_miso , Vs_clock , B , 1
   Vs_read = B
   Shift Vs_read , Left , 8
   B = 0
   Shiftin Vs_miso , Vs_clock , B , 1
   Vs_read = Vs_read + B
  Xcs = 1
End Function
'-------------------------------------------------------------------------------
'-------------------------------- WRITE ROUTINE --------------------------------
'-------------------------------------------------------------------------------
Sub Vs_write(byval Vs_address As Byte , Byval Data1 As Byte , Byval Data2 As Byte)
  Xcs = 0
   B = Vs_wr
   Shiftout Vs_mosi , Vs_clock , B , 1
   Shiftout Vs_mosi , Vs_clock , Vs_address , 1
   Shiftout Vs_mosi , Vs_clock , Data1 , 1
   Shiftout Vs_mosi , Vs_clock , Data2 , 1
  Xcs = 1
End Sub
'-------------------------------------------------------------------------------
'------------------------------------- RESET -----------------------------------
'-------------------------------------------------------------------------------
Sub Vs_init()
  Xreset = 0
    Waitms 5
  Xreset = 1
    Waitms 10

  Do : Led = Dreq : Loop Until Dreq = 1
  Vs_write Vs_mode , &H0 , &H4

  Do : Led = Dreq : Loop Until Dreq = 1
  Mode_low.7 = 1
  Vs_write Vs_mode , &H0 , Mode_low

  Do : Led = Dreq : Loop Until Dreq = 1
  Vs_write Vs_clockf , &H0 , &H0

  Do : Led = Dreq : Loop Until Dreq = 1
  Vs_write Vs_volume , &H0 , &H0

End Sub
'-------------------------------------------------------------------------------
'--------------------------- SOFT RESET VS1001 ---------------------------------
'-------------------------------------------------------------------------------
Sub Soft_reset
  Do : Led = Dreq : Loop Until Dreq = 1
  Vs_write Vs_mode , &H0 , &H4
End Sub
'-------------------------------------------------------------------------------
'---------------------------- SEND FILE MP3 ------------------------------------
'-------------------------------------------------------------------------------
Sub Send_mp3(byval Filename As String)
Cls
  Lcd "Play : " ; Filename
  Soft_reset
  Flag_read = 1
  Flag_play = 0

  Open Filename For Binary As #10

  Do : Led = Dreq : Loop Until Dreq = 1

  While Eof(#10) = 0
        Get #10 , Mmc_data(1) , , 512
        Do : Led = Dreq : Loop Until Dreq = 1

        For I = 1 To 16
            For J = 1 To 32
              Bsync = 1
                Shiftout Vs_mosi , Vs_clock , Mmc_data(curbyte) , 1
              Bsync = 0
            Incr Curbyte
            Next J
       Do : Led = Dreq : Loop Until Dreq = 1
       Next I
    Curbyte = 1
    Debounce Avanti , 0 , Esci , Sub
    Flag_play = 1
      If Pind.1 = 0 And Volume_low < 250 Then
         Volume_hig = Volume_hig + 5
         Volume_low = Volume_low + 5
         Bsync = 0
         Vs_write Vs_volume , Volume_hig , Volume_low
      End If
      If Pind.2 = 0 And Volume_low > 0 Then
         Volume_hig = Volume_hig - 5
         Volume_low = Volume_low - 5
         Bsync = 0
         Vs_write Vs_volume , Volume_hig , Volume_low
      End If
  Wend

Esci:
  Flag_play = 0
  Close #10
  For I = 1 To 2048
    B = 0
    Shiftout Vs_mosi , Vs_clock , B , 1
  Next I
  Locate 2 , 1
  Lcd "MP3 End"

  Waitms 100                                               
End Sub
'-------------------------------------------------------------------------------